<?php
final class SmsLink_8 { // idehpayam.ir [...]
	public $wsdl   = 'http://{SiteURL}/webservice/?WSDL';
	public $type   = 'XML';
	public $data   = array();
	public $errors = array();
	
	public function Connect() {
		$options = array(
			'login'    => $this->data['Config']['UserName'],
			'password' => $this->data['Config']['UserPassword']
		);
	
		$this->data['Proxy'] = new SoapClient(str_replace('{SiteURL}', $this->data['Config']['SiteUrl'], $this->wsdl), $options);
	}
	
	public function GetCredit() {
		$this->Connect();
		$this->data['Calls']['GetCredit'] = $this->data['Proxy']->accountInfo();
		$this->data['Calls']['GetCredit'] = isset($this->data['Calls']['GetCredit']->remaining) ? $this->data['Calls']['GetCredit']->remaining : 'Not Available';
		
		return array(
			'credit' => $this->data['Calls']['GetCredit'], 
			'type' => 'Amount'
		);
	}
	
	public function SendSMS($to = array(), $message = '') {
		$this->Connect();
		
		try {
			$this->data['Calls']['SendSms'] = $this->data['Proxy']->sendToMany($to, $message, $this->data['Config']['NumberSend']);
		} 
		catch (SoapFault $sf) {
			$faultString = $sf->faultstring;
			$faultCode = $sf->faultcode;
			
			switch ($faultCode) {
				case '1' : $this->errors[] = 'نام کاربری یا رمز عبور صحیح نیست'; break;
				case '2' : $this->errors[] = 'اعتبار حساب کافی نیست'; break;
				case '3' : $this->errors[] = 'حساب کاربر فعال نیست'; break;
				case '4' : $this->errors[] = 'شماره گیرنده خالی است'; break;
				case '5' : $this->errors[] = 'شماره گیرنده معتبر نیست'; break;
				case '6' : $this->errors[] = 'شماره فرستنده معتبر نیست'; break;
				case '7' : $this->errors[] = 'هیچ شماره ای به حساب شما اختصاص نیافته است'; break;
				case '8' : $this->errors[] = 'متن پیام خالی است'; break;
				case '9' : $this->errors[] = 'متن پیام طولانی است'; break;
				case '10' : $this->errors[] = 'خطا در سرویس دهنده'; break;
				case '11' : $this->errors[] = 'خطا در برقراری ارتباط با سوئیچ مخابرات'; break;
				case '12' : $this->errors[] = 'شناسه پیام نامعتبر است'; break;
				case '13' : $this->errors[] = 'آدرس انتقال ترافیک معتبر نیست'; break;
				case '14' : $this->errors[] = 'رمز عبور خالی است'; break;
				case '15' : $this->errors[] = 'شما حق دسترسی به این ماژول را ندارید'; break;
				case '16' : $this->errors[] = 'این ماژول در حال حاضر قابل استفاده نیست'; break;
				case '17' : $this->errors[] = 'این ماژول برای شما غیرفعال شده است'; break;
				case '18' : $this->errors[] = 'مهلت استفاده از این ماژول خاتمه یافته است'; break;
				case '19' : $this->errors[] = 'مهلت استفاده از این شماره خاتمه یافته است'; break;
				case '20' : $this->errors[] = 'این شماره برای شما غیرفعال شده است'; break;
				case '21' : $this->errors[] = 'تعداد پارامترها در ارسال نظیر به نظیر یکسان نیست'; break;
				case '22' : $this->errors[] = 'تعداد مخاطبین بیش از حد مجاز است'; break;
			}
		}
		
		return isset($this->data['Calls']['SendSms']) ? $this->data['Calls']['SendSms'] : '';
	}
}
?>